// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1995
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Allgemeines Include fr Clipper-Anwendungen.
// *               Wird auch zur Nutzung der VLIB.LIB bentigt.
// *
// * (c) Copyright Volksfrsorge Deutsche Lebensversicherung AG, 1995
// *
// ********************************************************************
// * nderungen  :
// *
// * 15/05/96-hee: -Memvar fr Semaphoren aufgenommen
// * 31/10/96-hee: -Defines fr die Swap-Funktion aufgenommen
// * 15/12/95-hee: -Include erstellt
// ********************************************************************

#include "common.ch"
#include "error.ch"
#include "achoice.ch"
#include "inkey.ch"
#include "fileio.ch"
#include "box.ch"
#include "setcurs.ch"
#include "set.ch"
#include "fileman.ch"

// *** Allgemeine defines

#define A_BC_USER            "{'PROJEKT1','PROJEKT2','ANETTE','JOERG'}"

#define L_EXCLUSIVE          .T.
#define L_SHARED             .F.
#define L_HELL               .T.
#define L_NICHT_HELL         .F.

#define N_VPROT_RECLEN       80
#define C_DEF_DRUCKER        "104" // Default Drucker

// *** Defines fr SwapFunktion

#define C_SWP_CMD            1     // Befehl, der ausgefhrt wird
#define C_SWP_PAR            2     // Befehlsparameter
#define N_SWP_MEM            3     // Memory
#define C_SWP_RUN            4     // Run Pfad
#define C_SWP_TMP            5     // Pfad fr TempFiles
#define C_SWP_KEY            6     // Tastatureingaben
#define C_SWP_PRO            7     // Prompt
#define C_SWP_MG1            8     // Swap-Message1
#define C_SWP_MG2            9     // Swap-Message2

#define N_SWP_ANZ            9     // Anz Array Elemente fr Swap-Func

// *** Defines fr ScrollFunktion

#define N_SCROLL             45   // Anzahl Elemente im ScrollArray

#define SCROLL_INIT           0
#define SCROLL_NEU            1
#define SCROLL_AENDERN        2
#define SCROLL_LOESCHEN       3
#define SCROLL_FOLGE          4
#define SCROLL_BEENDEN_NEUANL 8
#define SCROLL_ENDE           9
#define SCROLL_REFRESH       10
#define SCROLL_SUCHE         11

// *** Defines fr Array aHicom fr die VLIB-Funktion x_hicom.prg

#define B_USER_FUNC           1
#define C_STANDORT            2
#define N_COM_PORT            3
#define N_BIT_LEN             4
#define N_STOP_BITS           5
#define N_BAUD_RATE           6
#define C_PARITY              7
#define N_BUFFER_SIZE         8
#define N_WAIT                9
#define C_RUF_NR             10
#define C_PASSWORD           11
#define C_AMO                12
#define L_PASSWORD           13
#define L_TRACE              14
#define N_MAX_LOOPS          15
#define C_ERROR_MSG          16
#define A_POSITIV_ARR        17
#define C_PRUEF_STR          18
#define N_ANZ_READ           19
#define C_LESE_ZUSTAND       20
#define L_LEERZEILEN         21
#define N_RETRIES            22
#define C_HICOM_MSG          23
#define L_RCV_ZAP            24
#define L_CTL_ZAP            25
#define L_GESTOPPT           26
#define L_DISPLAY            27
#define X_CARGO              28
#define A_NEGATIV_ARR        29
#define C_BUFFER_UEBERLAUF   30
#define C_RNR_ALTERNATE      31
#define C_DEV_RUF            32
#define C_DEV_ALT            33

// *** Public Variablen fr Systemumgebung

MEMVAR pcEXEPfad, pcDbfPfad, pcTextPfad, pcDbfVprotPfad, pcDefaultPfad

// *** Public Variablen fr ProgrammInfos

MEMVAR pcProgramm, pcAutoren, pcCR_Long, pcCR_Short, pcPrgVers, pcDokNr

// *** Public Variablen fr Broadcast Userliste und Konfigurationsdaten

MEMVAR paBC_User, pcExeVersion, pcConfUser, pcConfFile

// *** Public Variablen fr Farben

MEMVAR pcCol_Char
MEMVAR pcCol_Kopfzeile, pcCol_Fusszeile, pcCol_Meldung, pcCol_Titel
MEMVAR pcCol_Error, pcCol_Desktop, pcCol_Menu, pcCol_Password
MEMVAR pcCol_Ende, pcCol_Browse, pcCol_Edit, pcCol_Frage, pcCol_Showtime
MEMVAR pcCol_Index, pcCol_Idx2, pcCol_Auswahl, pcCol_Anzeige
MEMVAR pcCol_Standard, pcCol_Balken, pcCol_Colorspec, pcCol_Tschuess
MEMVAR pcUserName, pcStationID

// *** Public Variablen frs Drucken

MEMVAR pcDru_Zeilen, pcDru_Breite, pcDru_Ort, pcDru_Nr

// *** Public Variablen fr die permanente Zeitanzeige

MEMVAR plShowTime, pnZ_ShowTime, pnS_ShowTime

// *** Public Variablen fr die Verwaltung von Semaphoren

MEMVAR pnSemHandle

// *** Eigene Commands

#xtranslate FALSE   => .F.
#xtranslate TRUE    => .T.
#xtranslate CR      => Chr(13)
#xtranslate LF      => Chr(10)
#xtranslate CRLF    => CR + LF

#command DEFAULT <variable1> TO <value1> [, <variableN> TO <valueN> ] => ;
         IF <variable1> == NIL; <variable1> := <value1>; END;
         [; IF <variableN> == NIL; <variableN> := <valueN>; END ]

#translate ISSPACE(<var1>) => (<var1> == SPACE(LEN(<var1>)))

#command GETFIELD <row>, <col>, <var>, <pic>, <valid>, <when>, <msg> ;
                                                      ;
      => SetPos( <row>, <col> )                       ;
       ; AAdd( GetList, _GET_( <var>, <"var">, <pic>, ;
               <{valid}>, <{when}> ):display()        ;
             )                                        ;
      [; ATail(GetList):<msg>]                        ;
         ReadModal(GetList)                           ;
       ; GetList := {}

#command @ <top>, <left>, <bottom>, <right> SHADOWBOX <string>    ;
                                            [COLOR <color>]       ;
         => Scroll( <top>, <left>, <bottom>, <right> )            ;
          ; SetPos( <top>, <left> )                               ;
          ; DispBox(                                              ;
                     <top>, <left>, <bottom>, <right>, <string>   ;
                     [, <color> ]                                 ;
                   )                                              ;
          ; XSHADOW( <top>, <left>, <bottom>, <right> )
