// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1995
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zum Scrollen eines Arrays
// *
// * Regeln      : - Spezielle vom Aufrufer belegte Tasten werden in
// *                 einem Array hinterlegt, das folgendermaen:
// *
// *                 AADD( aTasten, { K_xy, {|a,b|UserFunc(a,b)} } )
// *
// *                 erstellt wird. (a) enthlt das ScrollArray und
// *                 (b) die momentane ArrayPosition, beim Drcken der
// *                 Taste.
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 21/12/95-hee: -bergabeparameter fr externe Funktionen ver-
// *                allgemeinert
// * 18/12/95-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XARRAYSCROLL( o, l, u, r, aArr, lEdit, lAnzeige, cColor, aTasten, cMskZeile, cBalken)

   LOCAL GetList:={}, aRetArr:={}
   LOCAL cSaveColor, cSaveSwitch, cText
   LOCAL nTaste, nMaxZeilen, nElemente:=LEN(aArr)
   LOCAL z, i, j

   IF VALTYPE(lEdit)     != "L"
      lEdit     := .F.
   ENDIF

   IF VALTYPE(lAnzeige)  != "L"
      lAnzeige  := .F.   // Nur Anzeigen und Func sofort wieder verlassen
   ENDIF

   IF VALTYPE(cColor)    != "C"
      cColor    := pcCol_Standard
   ENDIF

   IF VALTYPE(cMskZeile) != "C"
      cMskZeile := SPACE(r-l+1)
   ENDIF

   IF VALTYPE(aTasten)   != "A"
      aTasten   := {}
   ENDIF

   IF VALTYPE(cBalken)   != "C"
      cBalken   := pcCol_Balken
   ENDIF

   cSaveColor   := SETCOLOR() // sichern Farben des Aufrufers
   cSaveSwitch  := CSETALL()  // sichern Schalterstellungen des Aufrufers

   SET CURSOR OFF             // wg. Balken nicht bentigt
   SET CONFIRM ON             // Eingaben mit CR abschlieen

   nMaxZeilen := u-o+1        // Anzahl Fensterzeilen
   nTaste     := K_CTRL_HOME  // bewirkt 1. Anzeige des Bildschirms

   DO WHILE .T. .AND. nElemente > 0

      DO WHILE nTaste == 0
         nTaste := INKEY()
      ENDDO

      SETCOLOR(cColor)

      DO CASE
         CASE (nArrElem:=ASCAN(aTasten, {|a|a[1]==nTaste} )) > 0
              aRetArr  := EVAL(aTasten[nArrElem][2], aArr, j)
              IF VALTYPE(aRetArr) == "A"
                 IF EMPTY(aRetArr)
                    nElemente := 0           // Ende
                 ELSE
                    aArr      := aRetArr
                    nElemente := LEN(aArr)
                    nTaste    := K_CTRL_HOME // Bildschirm Refresh
                 ENDIF
              ELSE
                 nTaste       := 0
              ENDIF
              LOOP

         CASE nTaste == K_TAB .AND. (.NOT. lEdit) // markieren
              IF RIGHT(aArr[j],1) == CHR(251)
                 cText   := aArr[j]
                 aArr[j] := SUBSTR(cText,1,LEN(cText)-1)+SPACE(1)
              ELSE
                 cText   := aArr[j]
                 aArr[j] := SUBSTR(cText,1,LEN(cText)-1)+CHR(251)
              ENDIF
              @ z,l SAY aArr[j] COLOR cBalken

         CASE nTaste == K_RETURN .AND. (.NOT. lEdit)
              @ z,l SAY aArr[j]
              EXIT

         CASE ( nTaste == K_LEFT .OR. nTaste == K_RIGHT .OR. ;
              nTaste == K_TAB .OR. nTaste == K_RETURN ) .AND. lEdit
              SETCOLOR(pcCol_Edit)
              SETCURSOR(1)
              @ z,l GET aArr[j]
              READ
              SETCURSOR(0)
              @ z,l SAY aArr[j] COLOR cBalken

         CASE nTaste == K_ESC
              @ z,l SAY aArr[j]
              j := 0
              EXIT

         CASE nTaste == K_CTRL_HOME
              j := 1
              i := 1
              DO WHILE i <= nMaxZeilen
                 IF j <= nElemente
                    @ o+i-1,l SAY aArr[j]
                 ELSE
                    @ o+i-1,l SAY cMskZeile
                 ENDIF
                 i++
                 j++
              ENDDO
              j := 1
              @ o,l SAY aArr[j] COLOR cBalken
              z := o
              IF lAnzeige
                 // *** reine erste Anzeige und Funktion gleich
                 // *** wieder verlassen
                 @ z,l SAY aArr[j]
                 EXIT
              ENDIF

         CASE nTaste == K_HOME
              @ z,l SAY aArr[j]
              DO WHILE z > o
                 j := j-1
                 z := z-1
                 @ z,l SAY aArr[j]
              ENDDO
              @ o,l SAY aArr[j] COLOR cBalken
              z := o

         CASE nTaste == K_END
              @ z,l SAY aArr[j]
              DO WHILE z < o+nMaxZeilen-1
                 j++
                 IF j > nElemente
                    j := nElemente
                    EXIT
                 ENDIF
                 z++
                 @ z,l SAY aArr[j]
              ENDDO
              @ z,l SAY aArr[j] COLOR cBalken

         CASE nTaste == K_CTRL_END
              @ z,l SAY aArr[j]
              IF j >= nElemente-nMaxZeilen+1
                 DO WHILE j < nElemente
                    j++
                    z++
                    @ z,l SAY aArr[j]
                 ENDDO
                 @ z,l SAY aArr[j] COLOR cBalken
              ELSE
                 j := nElemente-nMaxZeilen+1
                 IF j < 1
                    j := 1
                 ENDIF
                 i := 1
                 DO WHILE i <= nMaxZeilen
                    IF j <= nElemente
                       @ o+i-1,l SAY aArr[j]
                    ELSE
                       @ o+i-1,l SAY cMskZeile
                    ENDIF
                    i++
                    j++
                 ENDDO
                 j := nElemente-nMaxZeilen+1
                 IF j < 1
                    j := 1
                 ENDIF
                 @ o,l SAY aArr[j] COLOR cBalken
                 z := o
              ENDIF

         CASE nTaste == K_PGDN .OR. nTaste == K_CTRL_PGDN
              i := 1
              IF z = o
                 j := j+nMaxZeilen
                 IF j > nElemente
                    j := nElemente
                 ENDIF
              ENDIF
              DO WHILE i <= nMaxZeilen
                 IF j <= nElemente
                    @ o+i-1,l SAY aArr[j]
                 ELSE
                    @ o+i-1,l SAY cMskZeile
                 ENDIF
                 i++
                 j++
              ENDDO
              j := j-nMaxZeilen
              @ o,l SAY aArr[j] COLOR cBalken
              z := o

         CASE nTaste == K_PGUP .OR. nTaste == K_CTRL_PGUP
              i := 1
              j := j-(nMaxZeilen-1)
              IF j < 1
                 j := 1
              ENDIF
              DO WHILE i <= nMaxZeilen
                 IF j <= nElemente
                    @ o+i-1,l SAY aArr[j]
                 ELSE
                    @ o+i-1,l SAY cMskZeile
                 ENDIF
                 i++
                 j++
              ENDDO
              j := j-nMaxZeilen
              IF j < 1
                 j := 1
              ENDIF
              @ o,l SAY aArr[j] COLOR cBalken
              z := o

         CASE nTaste == K_DOWN
              @ z,l SAY aArr[j]
              SETCOLOR(cColor)
              j++
              IF j > nElemente
                 j := nElemente
              ELSE
                 IF z > o+nMaxZeilen-2
                    SCROLL(o,l,u,r,+1)
                    z := o+nMaxZeilen-1
                 ELSE
                    z++
                 ENDIF
              ENDIF
              @ z,l SAY aArr[j] COLOR cBalken

         CASE nTaste == K_UP
              @ z,l SAY aArr[j]
              SETCOLOR(cColor)
              j--
              IF j < 1
                 j := 1
              ELSE
                 IF z < o+1
                    SCROLL(o,l,u,r,-1)
                    z := o
                 ELSE
                    z--
                 ENDIF
              ENDIF
              @ z,l SAY aArr[j] COLOR cBalken

      ENDCASE

      nTaste := 0

   ENDDO

   SETCOLOR(cSaveColor)
   CSETALL(cSaveSwitch)

RETURN(j)
