// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1996
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zum Bereitstellen eines DateiNamens
// *
// * Hinweise    : - Es wird ein DateiName bergeben und dieser mit
// *                 der nchsten freien LaufNummer in der Extension
// *                 an den Aufrufer zurckgegeben. Somit knnen
// *                 bis zu 999 Versionen einer Datei verwaltet werden.
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 11/03/97-hee: -Es knnen auch Directories bercksichtigt werden.
// * 11/09/96-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XFILE_VERSION(cDatei, cPfad, lDir)

   LOCAL aDateien:={}
   LOCAL cReturn:="", cName:="", cExt:=""
   LOCAL i:=0, nLen:=0, nMax:=0

   IF VALTYPE(cDatei)   == "C"

      IF VALTYPE(cPfad) != "C"
         cPfad := pcDbfPfad
      ENDIF

      cPfad    := STRTRAN(cPfad+"\","\\","\")    // Backslash anhngen

      IF VALTYPE(lDir)  != "L"                   // Directories bercksichtigen
         lDir  := .F.
      ENDIF

      cName    := ALLTRIM(cDatei)

      IF (i:=AT(".",cName)) > 0
         cName := SUBSTR(cName,1,i-1)            // Extension entfernen
      ENDIF

      aDateien := DIRECTORY(cPfad+cName+".*",IIF(lDir,"D",NIL))
      nLen     := LEN(aDateien)
      nMax     := 0

      FOR i:=1 TO nLen
          IF AT(".",aDateien[i][1]) > 0
             // *** Extension ist vorhanden
             cExt    := RIGHT(aDateien[i][1],3)
             IF XNUMERIC(cExt,.T.)
                // *** Extension ist numerisch
                nMax := MAX(VAL(cExt),nMax)
             ENDIF
          ENDIF
      NEXT

      nMax++                                     // Neue Nummer

      IF nMax > 999

         // *** berlauf verwalten

         FOR i:=1 TO 999
             DO CASE
                CASE FILE(cPfad+cName+"."+STRZERO(i,3,0))
                CASE XVERZEICHNIS(cPfad+cName+"."+STRZERO(i,3,0))
             OTHERWISE
                nMax := i                        // Freie Nr gefunden
                EXIT
             ENDCASE
         NEXT

         IF nMax > 999
            // *** Keine freie Nummer verfgbar; Dateien auslagern
            cExt := STRZERO(DOY(DATE()),3,0)
            DIRMAKE(cPfad+cName+"."+cExt)
            FOR i:=1 TO 999
                FILEMOVE(cPfad+cName+"."+STRZERO(i,3,0),cPfad+cName+"."+cExt+"\"+cName+"."+STRZERO(i,3,0))
            NEXT
            nMax := 1 // Mit 1 wieder beginnen
         ENDIF

      ENDIF

      cReturn := cName + "." + STRZERO(nMax,3,0) // Neuer VersionsName

   ENDIF

RETURN(cReturn)
