// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1995
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zur Stringverkettung der Felder eines
// *               Datenbanksatzes.
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 21/08/96-hee: -Trennzeichen vom Aufrufer whlbar
// * 15/12/95-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XFIELDSTR(lCompress, cChar, aFld)

   LOCAL aStruc:={}
   LOCAL cString, nAnzFelder, i

   // *** Es mu auf eine DBF selektiert sein und der
   // *** gewnschte Datensatz in dieser Datei mu bereits
   // *** positioniert sein

   IF VALTYPE(cChar)     != "C"
      cChar     := "#"
   ENDIF

   IF VALTYPE(lCompress) != "L"
      lCompress := .F.
   ENDIF

   aStruc       := DBSTRUCT()
   nAnzFelder   := FCOUNT()  // Anzahl Felder des Datensatzes
   cString      := ""

   IF VALTYPE(aFld)      != "A"
      aFld := {}
      FOR i:=1 TO nAnzFelder
          AADD(aFld,i)
      NEXT
   ENDIF

   FOR i := 1 TO nAnzFelder

       IF ASCAN(aFld,i) > 0

          // *** Anliegendes Feld gehrt zur Feldauswahl (der
          // *** Aufrufer kann ber das Array aFld eine Anzahl
          // *** von FeldNummern vorgeben, die er verkettet
          // *** als String zurckhaben mchte)

          DO CASE
             CASE VALTYPE(FIELDGET(i))   == "C"
                  IF lCompress
                     cString += ALLTRIM(FIELDGET(i))+cChar
                  ELSE
                     cString += FIELDGET(i)+cChar
                  ENDIF
             CASE VALTYPE(FIELDGET(i))   == "N"
                  IF lCompress
                     cString += ALLTRIM(STR(FIELDGET(i),aStruc[i][3],aStruc[i][4]))+cChar
                  ELSE
                     cString += STR(FIELDGET(i),aStruc[i][3],aStruc[i][4])+cChar
                  ENDIF
             CASE VALTYPE((FIELDGET(i))) == "D"
                  cString    += DTOC(FIELDGET(i))+cChar
             CASE VALTYPE((FIELDGET(i))) == "L"
                  cString    += IIF(FIELDGET(i),".T.",".F.")+cChar
             OTHERWISE
                  cString    += "<?Typ?>"+cChar
          ENDCASE

      ENDIF

   NEXT

   // *** Rckgabe ist eine String-Addition smtlicher Felder des
   // *** aktuell positionierten Datensatzes

RETURN(cString)
