// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1996
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zum Listen des Directories eines Laufwerks
// *               Es werden smtliche Files gelistet; falls ein
// *               Eintrag mit der PrfDatei bereinstimmt wird die
// *               UserDefinedFunction ausgefhrt.
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 18/12/96-hee: -Unterbrechnung ber XSTOP programmiert
// * 27/10/96-hee: -Bildschirmanzeige hinzugefgt
// * 25/10/96-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XLISTDIR(cLw, cPruef, bUDF, lQOUT)

   LOCAL lReturn:=.T.
   LOCAL aDir:={}
   LOCAL cVerz:=""
   LOCAL i:=0, nLen:=0
   LOCAL bBlock

   IF VALTYPE(lQOUT) != "L"
      lQOUT := .T.   // Defaultmig Pfad+Datei am BS anzeigen
   ENDIF

   DO CASE
      CASE RIGHT(cLw,1) == "\"
      CASE RIGHT(cLw,1) == ":" .OR. AT("\",cLw) > 0
           cVerz := "\"
      OTHERWISE
           cVerz := ":\"
   ENDCASE

   cVerz := STRTRAN(cLw+cVerz,"::",":")
   cVerz := STRTRAN(cVerz,"\..\","\")
   cVerz := STRTRAN(cVerz,"\.\","\")
   cVerz := STRTRAN(cVerz,"\\","\")

   IF !EMPTY(aDir:=DIRECTORY(cVerz,"D"))

      nLen   := LEN(aDir)
      bBlock := {|e|S_PRUEFEN(cVerz, e[1], cPruef, bUDF, lQOUT)}

      FOR i:=1 TO nLen
          EVAL(bBlock,aDir[i])
          IF XSTOP()
             lReturn := .F.
             EXIT
          ENDIF
      NEXT

   ENDIF

RETURN(lReturn)

STATIC FUNCTION S_PRUEFEN(cLw, cDatei, cPruef, bUDF, lQOUT)

   LOCAL lOk:=.F.

   IF cDatei == "." .OR. cDatei == ".."

   ELSE

      IF XVERZEICHNIS(cLw+cDatei)

         XLISTDIR(cLw+cDatei, cPruef, bUDF, lQOUT) // Rekursiver Aufruf !

      ELSE

         IF lQOUT
            QOUT(cLw+cDatei)  // Bildschirmanzeige
         ENDIF

         IF VALTYPE(cPruef) == "C"

            lOk    := .F.

            IF cPruef == "*.*"
               lOk := .T.
            ELSE
               lOk := XFILE_COMPARE(cPruef,cDatei)
            ENDIF

            IF lOk
               IF VALTYPE(bUDF) == "B"
                  EVAL(bUDF,cLw+cDatei)
               ENDIF
            ENDIF

         ENDIF

      ENDIF

   ENDIF

RETURN(0)
