// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1995
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion prft String auf Numeric
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 22/10/96-hee: -Blank darf in einem Numeric vorkommen, d.h. '  123'
// *                ist numeric.
// * 06/06/96-hee: -Mglichkeit auf ReinNumeric zu prfen hinzugefgt
// * 01/03/96-hee: -Funktion verbessert; jetzt auch Kommata und
// *                Vorzeichen zulssig
// * 19/12/95-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XNUMERIC( cFeld, lReinNumeric )

   LOCAL lReturn:=.F.
   LOCAL cTmpFld

   IF LEN(ALLTRIM(cFeld)) > 0

      // *** Reine Leerfelder gelten nicht als numeric

      IF VALTYPE(lReinNumeric) != "L"
         lReinNumeric := .F.
      ENDIF

      // *** Aus dem bergabestring alles entfernen, was nicht zu
      // *** einem Numeric pat.

      IF lReinNumeric
         cTmpFld := CHARONLY("0123456789"    ,cFeld)
      ELSE
         cTmpFld := CHARONLY("0123456789+-,.",cFeld)
      ENDIF

      IF STRTRAN(cFeld," ","") == cTmpFld
         // *** String vorher ist identisch mit dem String nach dem
         // *** nicht-numerisches entfernt wurde, also handelt
         // *** es sich um einen Numeric.
         // *** Strtran stellt sicher, da auch innere Blanks entfernt
         // *** werden.
         lReturn := .T.
      ENDIF

   ENDIF

RETURN(lReturn)
