// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1995
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zum Andrucken des Bildschirminhalts
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 27/05/97-hee: -Drucken einer Textdatei hinzugefgt
// * 14/04/97-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XPRINTSCREEN(cTitel)

   LOCAL i

   XMELDUNG("Druckaufbereitung luft ...")

   IF VALTYPE(cTitel) != "C"
      cTitel := pcProgramm + " Bildschirmdruck"
   ENDIF

   DO WHILE .T.

      IF ISPRINTER()

         SET DEVICE TO PRINT

         @  1       , 3 SAY LEFT(cTitel+SPACE(72),72-LEN(cTitel)-17) + DTOC(DATE()) + "/" + TIME()
         @  PROW()+2, 3 SAY ""

         FOR i:=1 TO 25
             @ PROW()+1,3 SAY CHARODD(SCREENSTR(i-1,0,79))
         NEXT

         EJECT

         SET DEVICE TO SCREEN

         EXIT

      ELSE

         IF XFRAGE("Drucker nicht aktiv; fortfahren") == "N"
            EXIT
         ENDIF

      ENDIF

   ENDDO

RETURN(0)

FUNCTION XPRINTFILE(cDatei)

   LOCAL lEof:=.F.
   LOCAL i, nHandle
   LOCAL cZeile:="", cChar:=""

   XMELDUNG("Druckaufbereitung luft ...")

   IF (nHandle := FOPEN(pcTextPfad+cDatei,FO_READ+FO_SHARED)) > 0

      DO WHILE .T.

         IF ISPRINTER()

            SET DEVICE TO PRINT

            DO WHILE .T.

               cZeile    := ""

               DO WHILE .T.

                  cChar  := FREADSTR(nHandle,1)

                  DO CASE
                     CASE cChar == ""       // Dateiende
                          lEof  := .T.
                          EXIT
                     CASE cChar == CHR(12)  // x'0C' Seitenvorschub
                          EXIT
                     CASE cChar == CHR(13)  // x'0D' Carriage Return
                          EXIT
                     CASE cChar == CHR(10)  // x'0A' Line Feed
                          EXIT
                     OTHERWISE
                          cZeile += cChar
                  ENDCASE

               ENDDO

               IF PROW()+3 > 62
                  @  5, 3 SAY ""   // Seitenwechsel
               ENDIF

               @  PROW()+1, 3 SAY cZeile

               IF XSTOP()
                  EXIT
               ENDIF

               IF lEof
                  EXIT
               ENDIF

            ENDDO

            EJECT

            SET DEVICE TO SCREEN

            EXIT

         ELSE

            IF XFRAGE("Drucker nicht aktiv; fortfahren") == "N"
               EXIT
            ENDIF

         ENDIF

      ENDDO

      FCLOSE(nHandle)

   ENDIF

RETURN(0)
