// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1995
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zum Runden einer Zahl
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 03/06/96-hee: -Zustzliche Nachkommastelle bercksichtigt, um
// *                vorzeitiges Runden zu verhindern
// * 18/01/96-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XROUND(nWert,nLen,nDecimals)

   LOCAL nReturn, nSaveSetDec
   LOCAL lSaveSetFix
   LOCAL cWert

   nSaveSetDec := SET(_SET_DECIMALS)
   lSaveSetFix := SET(_SET_FIXED)

   SET DECIMALS TO (nDecimals+2)
   SET FIXED ON

   // *** Der zu rundende Wert wird mit zwei zustzlichen
   // *** Nachkommastellen dargestellt; dann wird die
   // *** letzte Nachkommastelle abgeschnitten:
   // ***
   // *** Darstellung  : 11,7945
   // *** Abgeschnitten: 11,794
   // ***
   // *** um die Aufrundung 4->5 in der dritten Nachkomma-
   // *** stelle im Beispiel zu verhindern. Die letzte
   // *** Nachkommastelle wird dann fr die Rundungsbetrachtung
   // *** herangezogen.

   cWert       := ALLTRIM(STR(nWert,nLen,nDecimals+2))
   cWert       := LEFT(cWert,LEN(cWert)-1)

   IF VAL(RIGHT(cWert,1)) >= 5
      nWert    := VAL(SUBSTR(cWert,1,LEN(cWert)-1)+"9")
   ELSE
      nWert    := VAL(SUBSTR(cWert,1,LEN(cWert)-1)+"0")
   ENDIF

   nReturn     := ROUND(nWert,nDecimals)

   SET(_SET_DECIMALS,nSaveSetDec)
   SET(_SET_FIXED   ,lSaveSetFix)

RETURN(nReturn)
