// ********************************************************************
// *
// * Autor(en)   : ebs EDV-Beratung-Service, Heiko Eggers, 1997
// * Gendert    : vgl. nderungen
// *
// * Beschreibung: Funktion zum Verwalten von Semaphoren (Netz)
// *
// * FREEWARE
// *
// ********************************************************************
// * nderungen  :
// *
// * 22/05/97-hee: -Abfrage, ob Netzwerk vorhanden ist
// * 15/05/97-hee: -Funktion erstellt
// ********************************************************************

#include "ebs_vlib.ch"

FUNCTION XSEM_OPEN()

   LOCAL nHandle:=0

   // *** Fr die Anwendung <pcProgramm> wird ein Semaphore geffnet
   // *** bzw. falls noch nicht vorhanden, initialisiert

   IF XNETWORK() == "NOVELL"

      IF (nHandle:=XNETSEMOPN(pcProgramm)) > 0
         XPROTOK("Semaphore geffnet")
      ELSE
         XMELDUNG("Fehler, Semaphore fr <"+pcProgramm+"> konnte nicht geffnet werden")
      ENDIF

   ENDIF

RETURN(nHandle)

FUNCTION XSEM_LOCK(nHandle)

   LOCAL lReturn:=.T.

   // *** Der Wert des Semaphore wird um 1 dekrementiert

   IF nHandle >  0
      lReturn := XNETSEMWAI( nHandle )   // Semaphore sperren
   ENDIF

RETURN(lReturn)

FUNCTION XSEM_UNLOCK(nHandle)

   LOCAL lReturn:=.T.

   // *** Der Wert des Semaphore wird um 1 inkrementiert

   IF nHandle >  0
      lReturn := XNETSEMSGN( nHandle )   // Semaphore freigeben
   ENDIF

RETURN(lReturn)

FUNCTION XSEM_INFO(nHandle)

   LOCAL aReturn:={}

   // *** Diese Funktion liefert fr einen speziellen SemaphoreHandle
   // *** die Anzahl Nutzer dieses Semaphore (kann z.B. zur Lizenz-
   // *** kontrolle verwendet werden) und den aktuellen Wert des
   // *** Semaphore.

   IF nHandle >  0
      aReturn := { XNETSEMOPC( nHandle ), XNETSEMVAL( nHandle ) }
   ENDIF

RETURN(aReturn)

FUNCTION XSEM_CLOSE(nHandle)

   LOCAL lReturn:=.F.

   IF nHandle > 0

      IF (lReturn:=XNETSEMCLO(nHandle))
         XPROTOK("Semaphore geschlossen")
      ELSE
         XPROTOK("Semaphore konnte nicht geschlossen werden")
      ENDIF

   ENDIF

RETURN(lReturn)
